Merge pull request #67 from mmichal10/execute-configure-in-parallel

Execute configure in parallel
This commit is contained in:
Michal Rakowski 2019-07-16 14:14:37 +02:00 committed by GitHub
commit a493b9d3fc
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
36 changed files with 1384 additions and 677 deletions

82
configure vendored
View File

@ -3,23 +3,83 @@
# Copyright(c) 2012-2019 Intel Corporation
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
which dirname 2>&1 > /dev/null || { echo >&2 "Eror: missing 'dirname' utility"; exit 1; }
which realpath 2>&1 > /dev/null || { echo >&2 "Eror: missing 'realpath' utility"; exit 1; }
check_util() {
which $1 2>&1 > /dev/null || { echo >&2 "Error: missing '$1' utility"; exit 1; }
}
check_util dirname
check_util realpath
check_util basename
check_util awk
SCRIPTPATH=`dirname $0`
SCRIPTPATH=`realpath $SCRIPTPATH`
CONFIG_FILES=`ls $SCRIPTPATH/configure.d/*.conf | sort`
FILES_COUNT=`echo $CONFIG_FILES | wc -w`
rm -f $SCRIPTPATH/modules/generated_defines.h
CONFIG_FILE=$SCRIPTPATH/"config.out"
files_count=`echo $CONFIG_FILES | wc -w`
progress=0
generate_config() {
rm -f ${CONFIG_FILE}
touch ${CONFIG_FILE}
declare -a pid_list
progress=0
for file in $CONFIG_FILES; do
progress=$((progress+1))
echo -ne "Configuring OpenCAS: $progress/$files_count\033[0K\r"
/bin/bash $file
done
echo -ne " \033[0K\r"
# Compile each test module in background
echo "Preparing configuration"
for file in $CONFIG_FILES; do
progress=$((progress+1))
# $1 - Action to be performed
# $2 - File with stored configuration
# $3 - Name of called script (since script is running as subprocess
# it has to be passed explicitly)
source $file "check" "$CONFIG_FILE" "$file" &
pid_list+=($!)
done
# Wait for all compilation processes to finish
wait
grep "X" ${CONFIG_FILE} &> /dev/null
if [ $? -eq 0 ] ; then
echo "ERROR! Following steps failed while preparing config:"
grep "X" ${CONFIG_FILE} | cut -f1 -d ' '
exit 1
fi
}
generate_header() {
rm -f $SCRIPTPATH/modules/generated_defines.h
# Configs starting with '1_' have to be put as first in header
FIRST=$(echo $CONFIG_FILES | tr ' ' '\n' | grep '1_')
SECOND=$(echo $CONFIG_FILES | tr ' ' '\n' | grep '2_')
echo "Configuring OpenCAS"
for file in $FIRST; do
CONF=$(cat ${CONFIG_FILE} | grep $(basename $file) | cut -d' ' -f2)
source $file "apply" "$CONF" "$file" &
done
wait
for file in $SECOND; do
CONF=$(cat ${CONFIG_FILE} | grep $(basename $file) | cut -d' ' -f2)
source $file "apply" "$CONF" "$file" &
done
wait
}
if [ -z "$1" ]; then
generate_config
else
CONFIG_FILE=$(realpath $1)
if [ $? -ne 0 ] ; then
echo "Invaild path to config file!"
exit 1
fi
fi
generate_header

View File

@ -4,13 +4,31 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct bio *b;blk_rq_append_bio(NULL, &b)" "linux/blkdev.h"
then
add_define "cas_blk_rq_append_bio(rq, bounce_bio) \\
blk_rq_append_bio(rq, &bounce_bio)"
else
add_define "cas_blk_rq_append_bio(rq, bounce_bio) \\
blk_rq_append_bio(rq, bounce_bio)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio *b;blk_rq_append_bio(NULL, &b)" "linux/blkdev.h"
then
echo $cur_name 1 >> $config_file_path
else
echo $cur_name 2 >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "cas_blk_rq_append_bio(rq, bounce_bio) \\
blk_rq_append_bio(rq, &bounce_bio)" ;;
"2")
add_define "cas_blk_rq_append_bio(rq, bounce_bio) \\
blk_rq_append_bio(rq, bounce_bio)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,14 +4,33 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "lookup_bdev(\"some_path\")" "linux/fs.h"
then
add_define "CAS_LOOKUP_BDEV(PATH) \\
lookup_bdev(PATH)"
elif compile_module "lookup_bdev(\"some_path\", 0)" "linux/fs.h"
then
add_define "CAS_LOOKUP_BDEV(PATH) \\
lookup_bdev(PATH, 0)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "lookup_bdev(\"some_path\")" "linux/fs.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "lookup_bdev(\"some_path\", 0)" "linux/fs.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_LOOKUP_BDEV(PATH) \\
lookup_bdev(PATH)" ;;
"2")
add_define "CAS_LOOKUP_BDEV(PATH) \\
lookup_bdev(PATH, 0)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,24 +4,45 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "bio_clone(NULL, 0)" "linux/bio.h"
then
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone(bio, gfp_mask);
}"
elif compile_module "bio_clone_kmalloc(NULL, 0)" "linux/bio.h"
then
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone_kmalloc(bio, gfp_mask);
}"
elif compile_module "bio_clone_fast(NULL, 0, NULL)" "linux/bio.h"
then
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone_fast(bio, gfp_mask, NULL);
}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "bio_clone(NULL, 0)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "bio_clone_kmalloc(NULL, 0)" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "bio_clone_fast(NULL, 0, NULL)" "linux/bio.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone(bio, gfp_mask);
}" ;;
"2")
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone_kmalloc(bio, gfp_mask);
}" ;;
"3")
add_function "static inline struct bio *cas_bio_clone(struct bio *bio, gfp_t gfp_mask)
{
return bio_clone_fast(bio, gfp_mask, NULL);
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,28 +4,46 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct bio b;b.bi_end_io(NULL, 0)" "linux/bio.h"
then
add_define "CAS_BIO_ENDIO(BIO, BYTES_DONE, ERROR) \\
bio_endio(BIO, ERROR)"
add_define "CAS_DECLARE_BLOCK_CALLBACK(name, BIO, BYTES_DONE, ERROR) \\
void name##_callback(BIO, ERROR)"
add_define "CAS_BLOCK_CALLBACK_ERROR(BIO, ERROR) \\
ERROR"
elif compile_module "struct bio b;b.bi_end_io(NULL)" "linux/bio.h"
then
add_define "CAS_BIO_ENDIO(BIO, BYTES_DONE, ERROR) \\
({ CAS_BIO_OP_STATUS(BIO) = ERROR; bio_endio(BIO); })"
add_define "CAS_DECLARE_BLOCK_CALLBACK(name, BIO, BYTES_DONE, ERROR) \\
void name##_callback(BIO)"
add_define "CAS_BLOCK_CALLBACK_ERROR(BIO, ERROR) \\
CAS_BIO_OP_STATUS(BIO)"
fi
add_define "CAS_REFER_BLOCK_CALLBACK(name) \\
name##_callback"
add_define "CAS_BLOCK_CALLBACK_INIT(BIO) \\
{; }"
add_define "CAS_BLOCK_CALLBACK_RETURN(BIO) \\
{ return; }"
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;b.bi_end_io(NULL, 0)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct bio b;b.bi_end_io(NULL)" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
add_define "CAS_REFER_BLOCK_CALLBACK(name) \\
name##_callback"
add_define "CAS_BLOCK_CALLBACK_INIT(BIO) \\
{; }"
add_define "CAS_BLOCK_CALLBACK_RETURN(BIO) \\
{ return; }"
case "$1" in
"1")
add_define "CAS_BIO_ENDIO(BIO, BYTES_DONE, ERROR) \\
bio_endio(BIO, ERROR)"
add_define "CAS_DECLARE_BLOCK_CALLBACK(name, BIO, BYTES_DONE, ERROR) \\
void name##_callback(BIO, ERROR)"
add_define "CAS_BLOCK_CALLBACK_ERROR(BIO, ERROR) \\
ERROR" ;;
"2")
add_define "CAS_BIO_ENDIO(BIO, BYTES_DONE, ERROR) \\
({ CAS_BIO_OP_STATUS(BIO) = ERROR; bio_endio(BIO); })"
add_define "CAS_DECLARE_BLOCK_CALLBACK(name, BIO, BYTES_DONE, ERROR) \\
void name##_callback(BIO)"
add_define "CAS_BLOCK_CALLBACK_ERROR(BIO, ERROR) \\
CAS_BIO_OP_STATUS(BIO)" ;;
esac
}
conf_run $@

View File

@ -4,30 +4,53 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "bio_op(NULL)" "linux/bio.h"
then
add_define "CAS_IS_DISCARD(bio) \\
(bio_op(bio) == REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
(REQ_OP_DISCARD)"
elif compile_module "REQ_OP_MASK" "linux/blk_types.h"
then
add_define "CAS_IS_DISCARD(bio) \\
(((CAS_BIO_OP_FLAGS(bio)) & REQ_OP_MASK) == REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
((REQ_OP_WRITE | REQ_OP_DISCARD))"
elif compile_module "REQ_OP_DISCARD" "linux/blk_types.h"
then
add_define "CAS_IS_DISCARD(bio) \\
((CAS_BIO_OP_FLAGS(bio)) & REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
((REQ_OP_WRITE | REQ_OP_DISCARD))"
elif compile_module "REQ_DISCARD" "linux/blk_types.h"
then
add_define "CAS_IS_DISCARD(bio) \\
((CAS_BIO_OP_FLAGS(bio)) & REQ_DISCARD)"
add_define "CAS_BIO_DISCARD \\
(REQ_WRITE | REQ_DISCARD)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "bio_op(NULL)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "REQ_OP_MASK" "linux/blk_types.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "REQ_OP_DISCARD" "linux/blk_types.h"
then
echo $cur_name "3" >> $config_file_path
elif compile_module $cur_name "REQ_DISCARD" "linux/blk_types.h"
then
echo $cur_name "4" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_IS_DISCARD(bio) \\
(bio_op(bio) == REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
(REQ_OP_DISCARD)" ;;
"2")
add_define "CAS_IS_DISCARD(bio) \\
(((CAS_BIO_OP_FLAGS(bio)) & REQ_OP_MASK) == REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
((REQ_OP_WRITE | REQ_OP_DISCARD))" ;;
"3")
add_define "CAS_IS_DISCARD(bio) \\
((CAS_BIO_OP_FLAGS(bio)) & REQ_OP_DISCARD)"
add_define "CAS_BIO_DISCARD \\
((REQ_OP_WRITE | REQ_OP_DISCARD))" ;;
"4")
add_define "CAS_IS_DISCARD(bio) \\
((CAS_BIO_OP_FLAGS(bio)) & REQ_DISCARD)"
add_define "CAS_BIO_DISCARD \\
(REQ_WRITE | REQ_DISCARD)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,14 +4,32 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;b.bi_status" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct bio b;b.bi_error" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_BIO_OP_STATUS(bio) \\
bio->bi_status" ;;
"2")
add_define "CAS_BIO_OP_STATUS(bio) \\
bio->bi_error" ;;
*)
exit 1
esac
}
conf_run $@
if compile_module "struct bio b;b.bi_status" "linux/bio.h"
then
add_define "CAS_BIO_OP_STATUS(bio) \\
bio->bi_status"
elif compile_module "struct bio b;b.bi_error" "linux/bio.h"
then
add_define "CAS_BIO_OP_STATUS(bio) \\
bio->bi_error"
fi

View File

@ -4,16 +4,35 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct bio b;b.bi_opf" "linux/bio.h"
then
add_define "CAS_BIO_OP_FLAGS_FORMAT \"0x%016X\""
add_define "CAS_BIO_OP_FLAGS(bio) \\
(bio)->bi_opf"
elif compile_module "struct bio b;b.bi_rw" "linux/bio.h"
then
add_define "CAS_BIO_OP_FLAGS_FORMAT \"0x%016lX\""
add_define "CAS_BIO_OP_FLAGS(bio) \\
(bio)->bi_rw"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;b.bi_opf" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct bio b;b.bi_rw" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_BIO_OP_FLAGS_FORMAT \"0x%016X\""
add_define "CAS_BIO_OP_FLAGS(bio) \\
(bio)->bi_opf" ;;
"2")
add_define "CAS_BIO_OP_FLAGS_FORMAT \"0x%016lX\""
add_define "CAS_BIO_OP_FLAGS(bio) \\
(bio)->bi_rw" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,22 +4,41 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct bio b;b.bi_iter.bi_size" "linux/bio.h"
then
add_define "CAS_BIO_BISIZE(bio) \\
bio->bi_iter.bi_size"
add_define "CAS_BIO_BIIDX(bio) \\
bio->bi_iter.bi_idx"
add_define "CAS_BIO_BISECTOR(bio) \\
bio->bi_iter.bi_sector"
elif compile_module "struct bio b;b.bi_size" "linux/bio.h"
then
add_define "CAS_BIO_BISIZE(bio) \\
bio->bi_size"
add_define "CAS_BIO_BIIDX(bio) \\
bio->bi_idx"
add_define "CAS_BIO_BISECTOR(bio) \\
bio->bi_sector"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;b.bi_iter.bi_size" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct bio b;b.bi_size" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_BIO_BISIZE(bio) \\
bio->bi_iter.bi_size"
add_define "CAS_BIO_BIIDX(bio) \\
bio->bi_iter.bi_idx"
add_define "CAS_BIO_BISECTOR(bio) \\
bio->bi_iter.bi_sector" ;;
"2")
add_define "CAS_BIO_BISIZE(bio) \\
bio->bi_size"
add_define "CAS_BIO_BIIDX(bio) \\
bio->bi_idx"
add_define "CAS_BIO_BISECTOR(bio) \\
bio->bi_sector" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct bio b;&bio_iovec(&b)" "linux/bio.h"
then
add_define "CAS_SEGMENT_BVEC(vec) \\
(&(vec))"
else
add_define "CAS_SEGMENT_BVEC(vec) \\
(vec)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;&bio_iovec(&b)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_SEGMENT_BVEC(vec) \\
(&(vec))" ;;
"2")
add_define "CAS_SEGMENT_BVEC(vec) \\
(vec)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "blk_rq_set_block_pc(NULL)" "linux/blkdev.h"
then
add_define "cas_blk_rq_set_block_pc(rq) \\
blk_rq_set_block_pc(rq)"
else
add_define "cas_blk_rq_set_block_pc(rq) \\
{}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "blk_rq_set_block_pc(NULL)" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "cas_blk_rq_set_block_pc(rq) \\
blk_rq_set_block_pc(rq)" ;;
"2")
add_define "cas_blk_rq_set_block_pc(rq) \\
{}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "deamonize(\"some_name\", NULL)" "linux/sched.h"
then
add_define "CAS_DAEMONIZE(name, arg...) \\
daemonize(name, ##arg)"
else
add_define "CAS_DAEMONIZE(name, arg...) \\
do { } while (0)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "deamonize(\"some_name\", NULL)" "linux/sched.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_DAEMONIZE(name, arg...) \\
daemonize(name, ##arg)" ;;
"2")
add_define "CAS_DAEMONIZE(name, arg...) \\
do { } while (0)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,14 +4,33 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct dentry dentry;dentry.d_u.d_alias" "linux/dcache.h"
then
add_define "CAS_ALIAS_NODE_TO_DENTRY(alias) \\
container_of(alias, struct dentry, d_u.d_alias)"
elif compile_module "struct dentry dentry;dentry.d_alias" "linux/dcache.h"
then
add_define "CAS_ALIAS_NODE_TO_DENTRY(alias) \\
container_of(alias, struct dentry, d_alias)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct dentry dentry;dentry.d_u.d_alias" "linux/dcache.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct dentry dentry;dentry.d_alias" "linux/dcache.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_ALIAS_NODE_TO_DENTRY(alias) \\
container_of(alias, struct dentry, d_u.d_alias)" ;;
"2")
add_define "CAS_ALIAS_NODE_TO_DENTRY(alias) \\
container_of(alias, struct dentry, d_alias)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct queue_limits q;q.discard_zeroes_data" "linux/blkdev.h"
then
add_define "CAS_SET_DISCARD_ZEROES_DATA(queue_limits, val) \\
queue_limits.discard_zeroes_data = val"
else
add_define "CAS_SET_DISCARD_ZEROES_DATA(queue_limits, val) \\
({})"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct queue_limits q;q.discard_zeroes_data" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_SET_DISCARD_ZEROES_DATA(queue_limits, val) \\
queue_limits.discard_zeroes_data = val" ;;
"2")
add_define "CAS_SET_DISCARD_ZEROES_DATA(queue_limits, val) \\
({})" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,18 +4,37 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "REQ_PREFLUSH" "linux/blk_types.h"
then
add_define "CAS_REQ_FLUSH \\
REQ_PREFLUSH"
add_define "CAS_FLUSH_SUPPORTED \\
1"
elif compile_module "REQ_FLUSH" "linux/blk_types.h"
then
add_define "CAS_REQ_FLUSH \\
REQ_FLUSH"
add_define "CAS_FLUSH_SUPPORTED \\
1"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "REQ_PREFLUSH" "linux/blk_types.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "REQ_FLUSH" "linux/blk_types.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_REQ_FLUSH \\
REQ_PREFLUSH"
add_define "CAS_FLUSH_SUPPORTED \\
1" ;;
"2")
add_define "CAS_REQ_FLUSH \\
REQ_FLUSH"
add_define "CAS_FLUSH_SUPPORTED \\
1" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,82 +4,104 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if
compile_module "generic_start_io_acct(NULL, 0, 0, NULL)" "linux/bio.h"
then
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part) {
generic_start_io_acct(q, rw, sectors, part);
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
generic_end_io_acct(q, rw, part, start_time);
}"
elif compile_module "generic_start_io_acct(0, 0, NULL)" "linux/bio.h"
then
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
generic_start_io_acct(rw, sectors, part);
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
generic_end_io_acct(rw, part, start_time);
}"
elif compile_module "part_round_stats(1, 1)" "linux/genhd.h"
then
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
int cpu = part_stat_lock();
part_round_stats(cpu, part);
part_stat_inc(cpu, part, ios[rw]);
part_stat_add(cpu, part, sectors[rw], sectors);
part_inc_in_flight(part, rw);
part_stat_unlock();
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
unsigned long duration = jiffies - start_time;
int cpu = part_stat_lock();
part_stat_add(cpu, part, ticks[rw], duration);
part_round_stats(cpu, part);
part_dec_in_flight(part, rw);
part_stat_unlock();
}"
elif compile_module "part_round_stats(NULL, 1, 1)" "linux/genhd.h"
then
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
int cpu = part_stat_lock();
part_round_stats(NULL, cpu, part);
part_stat_inc(cpu, part, ios[rw]);
part_stat_add(cpu, part, sectors[rw], sectors);
part_inc_in_flight(NULL, part, rw);
part_stat_unlock();
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
unsigned long duration = jiffies - start_time;
int cpu = part_stat_lock();
part_stat_add(cpu, part, ticks[rw], duration);
part_round_stats(NULL, cpu, part);
part_dec_in_flight(NULL, part, rw);
part_stat_unlock();
}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "generic_start_io_acct(NULL, 0, 0, NULL)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "generic_start_io_acct(0, 0, NULL)" "linux/bio.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "part_round_stats(1, 1)" "linux/genhd.h"
then
echo $cur_name "3" >> $config_file_path
elif compile_module $cur_name "part_round_stats(NULL, 1, 1)" "linux/genhd.h"
then
echo $cur_name "4" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part) {
generic_start_io_acct(q, rw, sectors, part);
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
generic_end_io_acct(q, rw, part, start_time);
}" ;;
"2")
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
generic_start_io_acct(rw, sectors, part);
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
generic_end_io_acct(rw, part, start_time);
}" ;;
"3")
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
int cpu = part_stat_lock();
part_round_stats(cpu, part);
part_stat_inc(cpu, part, ios[rw]);
part_stat_add(cpu, part, sectors[rw], sectors);
part_inc_in_flight(part, rw);
part_stat_unlock();
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
unsigned long duration = jiffies - start_time;
int cpu = part_stat_lock();
part_stat_add(cpu, part, ticks[rw], duration);
part_round_stats(cpu, part);
part_dec_in_flight(part, rw);
part_stat_unlock();
}" ;;
"4")
add_function "
static inline void cas_generic_start_io_acct(struct request_queue *q,
int rw, unsigned long sectors, struct hd_struct *part)
{
int cpu = part_stat_lock();
part_round_stats(NULL, cpu, part);
part_stat_inc(cpu, part, ios[rw]);
part_stat_add(cpu, part, sectors[rw], sectors);
part_inc_in_flight(NULL, part, rw);
part_stat_unlock();
}"
add_function "
static inline void cas_generic_end_io_acct(struct request_queue *q,
int rw, struct hd_struct *part, unsigned long start_time)
{
unsigned long duration = jiffies - start_time;
int cpu = part_stat_lock();
part_stat_add(cpu, part, ticks[rw], duration);
part_round_stats(NULL, cpu, part);
part_dec_in_flight(NULL, part, rw);
part_stat_unlock();
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,29 +4,47 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "global_zone_page_state(1)" "linux/mm.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "global_page_state(1)" "linux/mm.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
if compile_module "global_zone_page_state(1)" "linux/mm.h"
then
add_function "
static inline unsigned long cas_global_zone_page_state(enum zone_stat_item item)
{
return global_zone_page_state(item);
}"
add_define "CAS_BIO_SET_DEV(bio, bdev) \\
bio_set_dev(bio, bdev)"
add_define "CAS_BIO_GET_DEV(bio) \\
bio->bi_disk"
elif compile_module "global_page_state(1)" "linux/mm.h"
then
add_function "
static inline unsigned long cas_global_zone_page_state(enum zone_stat_item item)
{
return global_page_state(item);
}"
add_define "CAS_BIO_SET_DEV(bio, bdev) \\
bio->bi_bdev = bdev"
add_define "CAS_BIO_GET_DEV(bio) \\
bio->bi_bdev->bd_disk"
fi
apply() {
case "$1" in
"1")
add_function "
static inline unsigned long cas_global_zone_page_state(enum zone_stat_item item)
{
return global_zone_page_state(item);
}"
add_define "CAS_BIO_SET_DEV(bio, bdev) \\
bio_set_dev(bio, bdev)"
add_define "CAS_BIO_GET_DEV(bio) \\
bio->bi_disk" ;;
"2")
add_function "
static inline unsigned long cas_global_zone_page_state(enum zone_stat_item item)
{
return global_page_state(item);
}"
add_define "CAS_BIO_SET_DEV(bio, bdev) \\
bio->bi_bdev = bdev"
add_define "CAS_BIO_GET_DEV(bio) \\
bio->bi_bdev->bd_disk" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,22 +4,41 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct hlist_node list" "linux/types.h"
then
add_define "CAS_ALIAS_NODE_TYPE \\
struct hlist_node"
add_define "CAS_DENTRY_LIST_EMPTY(head) \\
hlist_empty(head)"
add_define "CAS_INODE_FOR_EACH_DENTRY(pos, head) \\
hlist_for_each(pos, head)"
elif compile_module "struct list_head list" "linux/list.h"
then
add_define "CAS_ALIAS_NODE_TYPE \\
struct list_head"
add_define "CAS_DENTRY_LIST_EMPTY(head) \\
list_empty(head)"
add_define "CAS_INODE_FOR_EACH_DENTRY(pos, head) \\
list_for_each(pos, head)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct hlist_node list" "linux/types.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct list_head list" "linux/list.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_ALIAS_NODE_TYPE \\
struct hlist_node"
add_define "CAS_DENTRY_LIST_EMPTY(head) \\
hlist_empty(head)"
add_define "CAS_INODE_FOR_EACH_DENTRY(pos, head) \\
hlist_for_each(pos, head)" ;;
"2")
add_define "CAS_ALIAS_NODE_TYPE \\
struct list_head"
add_define "CAS_DENTRY_LIST_EMPTY(head) \\
list_empty(head)"
add_define "CAS_INODE_FOR_EACH_DENTRY(pos, head) \\
list_for_each(pos, head)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,14 +4,33 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct file file;file.f_inode" "linux/fs.h"
then
add_define "CAS_FILE_INODE(file) \\
file->f_inode"
elif compile_module "struct file file;file->f_dentry->d_inode" "linux/fs.h"
then
add_define "CAS_FILE_INODE(file) \\
file->f_dentry->d_inode"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct file file;file.f_inode" "linux/fs.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct file file;file->f_dentry->d_inode" "linux/fs.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_FILE_INODE(file) \\
file->f_inode" ;;
"2")
add_define "CAS_FILE_INODE(file) \\
file->f_dentry->d_inode" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,36 +4,55 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "vm_munmap(0, 0)" "linux/mm.h"
then
add_function "
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "vm_munmap(0, 0)" "linux/mm.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "do_munmap(NULL, 0)" "linux/mm.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
#include <uapi/asm-generic/mman-common.h>
static inline unsigned long cas_vm_mmap(struct file *file,
unsigned long addr, unsigned long len)
{
return vm_mmap(file, addr, len, PROT_READ | PROT_WRITE,
MAP_ANONYMOUS | MAP_PRIVATE, 0);
}"
add_function "
static inline int cas_vm_munmap(unsigned long start, size_t len)
{
return vm_munmap(start, len);
}"
elif compile_module "do_munmap(NULL, 0)" "linux/mm.h"
then
add_function "
static inline unsigned long cas_vm_mmap(struct file *file,
unsigned long addr, unsigned long len)
{
return vm_mmap(file, addr, len, PROT_READ | PROT_WRITE,
MAP_ANONYMOUS | MAP_PRIVATE, 0);
}"
add_function "
static inline int cas_vm_munmap(unsigned long start, size_t len)
{
return vm_munmap(start, len);
}" ;;
"2")
add_function "
#include <asm-generic/mman-common.h>
static inline unsigned long cas_vm_mmap(struct file *file,
unsigned long addr, unsigned long len)
{
return do_mmap_pgoff(file, addr, len, PROT_READ | PROT_WRITE,
MAP_ANONYMOUS | MAP_PRIVATE, 0);
}"
add_function "
static inline int cas_vm_munmap(unsigned long start, size_t len)
{
return do_munmap(current->mm, start, len);
}"
fi
static inline unsigned long cas_vm_mmap(struct file *file,
unsigned long addr, unsigned long len)
{
return do_mmap_pgoff(file, addr, len, PROT_READ | PROT_WRITE,
MAP_ANONYMOUS | MAP_PRIVATE, 0);
}"
add_function "
static inline int cas_vm_munmap(unsigned long start, size_t len)
{
return do_munmap(current->mm, start, len);
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "blk_queue_bounce(NULL, NULL);" "linux/blkdev.h"
then
add_define "cas_blk_queue_bounce(q, bounce_bio) \\
blk_queue_bounce(q, bounce_bio)"
else
add_define "cas_blk_queue_bounce(q, bounce_bio) \\
({})"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "blk_queue_bounce(NULL, NULL);" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "cas_blk_queue_bounce(q, bounce_bio) \\
blk_queue_bounce(q, bounce_bio)" ;;
"2")
add_define "cas_blk_queue_bounce(q, bounce_bio) \\
({})" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "struct request_queue q;q.limits.chunk_sectors" "linux/blkdev.h"
then
add_define "CAS_SET_QUEUE_CHUNK_SECTORS(queue, chunk_size) \\
queue->limits.chunk_sectors = chunk_size"
else
add_define "CAS_SET_QUEUE_CHUNK_SECTORS(queue, chunk_size) \\
{;}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct request_queue q;q.limits.chunk_sectors" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_SET_QUEUE_CHUNK_SECTORS(queue, chunk_size) \\
queue->limits.chunk_sectors = chunk_size" ;;
"2")
add_define "CAS_SET_QUEUE_CHUNK_SECTORS(queue, chunk_size) \\
{;}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,13 +4,30 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "blk_queue_flag_set(0, NULL)" "linux/blkdev.h"
then
add_define "cas_queue_flag_set_unlocked(flag, request_queue) \\
blk_queue_flag_set(flag, request_queue)"
else
add_define "cas_queue_flag_set_unlocked(flag, request_queue) \\
queue_flag_set_unlocked(flag, request_queue)"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "blk_queue_flag_set(0, NULL)" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "cas_queue_flag_set_unlocked(flag, request_queue) \\
blk_queue_flag_set(flag, request_queue)" ;;
"2")
add_define "cas_queue_flag_set_unlocked(flag, request_queue) \\
queue_flag_set_unlocked(flag, request_queue)" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,50 +4,71 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
# RHEL 7.3
if compile_module "struct queue_limits q;q.limits_aux" "linux/blkdev.h"
then
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
struct queue_limits_aux *l_aux = exp_q->limits.limits_aux;
exp_q->limits = cache_q->limits;
exp_q->limits.limits_aux = l_aux;
if (exp_q->limits.limits_aux && cache_q->limits.limits_aux)
*exp_q->limits.limits_aux = *cache_q->limits.limits_aux;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
if (queue_virt_boundary(cache_q))
queue_flag_set(QUEUE_FLAG_NOMERGES, cache_q);
}"
elif compile_module "struct queue_limits q;q.max_write_zeroes_sectors" "linux/blkdev.h"
then
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
exp_q->limits = cache_q->limits;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
exp_q->limits.max_write_zeroes_sectors = 0;
}"
elif compile_module "struct queue_limits q;q.max_write_same_sectors" "linux/blkdev.h"
then
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
exp_q->limits = cache_q->limits;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct queue_limits q;q.limits_aux" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct queue_limits q;q.max_write_zeroes_sectors" "linux/blkdev.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "struct queue_limits q;q.max_write_same_sectors" "linux/blkdev.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
struct queue_limits_aux *l_aux = exp_q->limits.limits_aux;
exp_q->limits = cache_q->limits;
exp_q->limits.limits_aux = l_aux;
if (exp_q->limits.limits_aux && cache_q->limits.limits_aux)
*exp_q->limits.limits_aux = *cache_q->limits.limits_aux;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
if (queue_virt_boundary(cache_q))
queue_flag_set(QUEUE_FLAG_NOMERGES, cache_q);
}" ;;
"2")
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
exp_q->limits = cache_q->limits;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
exp_q->limits.max_write_zeroes_sectors = 0;
}" ;;
"3")
add_function "
static inline void cas_copy_queue_limits(struct request_queue *exp_q,
struct request_queue *cache_q, struct request_queue *core_q)
{
exp_q->limits = cache_q->limits;
exp_q->limits.max_sectors = core_q->limits.max_sectors;
exp_q->limits.max_hw_sectors = core_q->limits.max_hw_sectors;
exp_q->limits.max_segments = core_q->limits.max_segments;
exp_q->limits.max_write_same_sectors = 0;
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,27 +4,44 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "REQ_TYPE_FS" "linux/blkdev.h"
then
add_function "
static inline int cas_is_rq_type_fs(struct request *rq)
{
return rq->cmd_type == REQ_TYPE_FS;
}"
else
add_function "
static inline int cas_is_rq_type_fs(struct request *rq)
{
switch (req_op(rq)){
case REQ_OP_READ:
case REQ_OP_WRITE:
case REQ_OP_FLUSH:
case REQ_OP_DISCARD:
return true;
default:
return false;
}
}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "REQ_TYPE_FS" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
static inline int cas_is_rq_type_fs(struct request *rq)
{
return rq->cmd_type == REQ_TYPE_FS;
}" ;;
"2")
add_function "
static inline int cas_is_rq_type_fs(struct request *rq)
{
switch (req_op(rq)){
case REQ_OP_READ:
case REQ_OP_WRITE:
case REQ_OP_FLUSH:
case REQ_OP_DISCARD:
return true;
default:
return false;
}
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,41 +4,64 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
# submit_bio() can be defined in "bio.h" or in "fs.h"
# If it is defind in fs.h, three possibilities are available:
# * it takes one argument and retuns non-void
# * it takes two arguments and returns non-void
# * it takse two arguments and is void-type
if compile_module "submit_bio(NULL)" "linux/bio.h"
then
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
CAS_BIO_OP_FLAGS(bio) |= rw;
return submit_bio(bio);
}"
elif compile_module "submit_bio(NULL)" "linux/fs.h"
then
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
CAS_BIO_OP_FLAGS(bio) |= rw;
return submit_bio(bio);
}"
elif compile_module "void *t=submit_bio(0, NULL)" "linux/fs.h"
then
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
return submit_bio(rw, bio);
}"
elif compile_module "submit_bio(0, NULL)" "linux/fs.h"
then
add_function "
static inline void cas_submit_bio(int rw, struct bio *bio)
{
submit_bio(rw, bio);
}"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "submit_bio(NULL)" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "submit_bio(NULL)" "linux/fs.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "void *t=submit_bio(0, NULL)" "linux/fs.h"
then
echo $cur_name "4" >> $config_file_path
elif compile_module $cur_name "submit_bio(0, NULL)" "linux/fs.h"
then
echo $cur_name "4" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
CAS_BIO_OP_FLAGS(bio) |= rw;
return submit_bio(bio);
}" ;;
"2")
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
CAS_BIO_OP_FLAGS(bio) |= rw;
return submit_bio(bio);
}" ;;
"3")
add_function "
static inline blk_qc_t cas_submit_bio(int rw, struct bio *bio)
{
return submit_bio(rw, bio);
}" ;;
"4")
add_function "
static inline void cas_submit_bio(int rw, struct bio *bio)
{
submit_bio(rw, bio);
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -1,13 +0,0 @@
#!/bin/bash
#
# Copyright(c) 2012-2019 Intel Corporation
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
if compile_module "struct bio b;b.bi_write_hint" "linux/bio.h"
then
add_define "CAS_WLTH_SUPPORT \\
1"
fi

View File

@ -4,14 +4,33 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "WRITE" "linux/blk_types.h"
then
add_define "CAS_RQ_DATA_DIR_WR \\
WRITE"
elif compile_module "REQ_WRITE" "linux/blk_types.h"
then
add_define "CAS_RQ_DATA_DIR_WR \\
REQ_WRITE"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "WRITE" "linux/blk_types.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "REQ_WRITE" "linux/blk_types.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_RQ_DATA_DIR_WR \\
WRITE" ;;
"2")
add_define "CAS_RQ_DATA_DIR_WR \\
REQ_WRITE" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,29 +4,52 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "WRITE_FUA" "linux/fs.h"
then
add_define "CAS_WRITE_FUA \\
WRITE_FUA"
if compile_module "BIO_FUA" "linux/bio.h"
then
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & BIO_FUA)"
else
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & REQ_FUA)"
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "WRITE_FUA" "linux/fs.h"
then
if compile_module $cur_name "BIO_FUA" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
elif compile_module $cur_name "REQ_FUA" "linux/blk_types.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "4" >> $config_file_path
fi
elif compile_module "REQ_FUA" "linux/blk_types.h"
then
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & REQ_FUA)"
add_define "CAS_WRITE_FUA \\
REQ_FUA"
else
add_define "CAS_IS_WRITE_FUA(flags) \\
0"
add_define "CAS_WRITE_FUA \\
WRITE_BARRIER"
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_WRITE_FUA \\
WRITE_FUA"
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & BIO_FUA)" ;;
"2")
add_define "CAS_WRITE_FUA \\
WRITE_FUA"
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & REQ_FUA)" ;;
"3")
add_define "CAS_IS_WRITE_FUA(flags) \\
((flags) & REQ_FUA)"
add_define "CAS_WRITE_FUA \\
REQ_FUA" ;;
"4")
add_define "CAS_IS_WRITE_FUA(flags) \\
0"
add_define "CAS_WRITE_FUA \\
WRITE_BARRIER" ;;
*)
exit 1
esac
}
conf_run $@

28
configure.d/1_wtlh.conf Normal file
View File

@ -0,0 +1,28 @@
#!/bin/bash
#
# Copyright(c) 2012-2019 Intel Corporation
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. $(dirname $3)/conf_framework
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "struct bio b;b.bi_write_hint" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_WLTH_SUPPORT \\
1" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,18 +4,39 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "RQF_SOFTBARRIER" "linux/blkdev.h"
then
add_define "CAS_CHECK_BARRIER(bio) \\
((CAS_BIO_OP_FLAGS(bio) & RQF_SOFTBARRIER) != 0)"
elif compile_module "REQ_SOFTBARRIER" "linux/blk_types.h"
then
add_define "CAS_CHECK_BARRIER(bio) \\
((CAS_BIO_OP_FLAGS(bio) & REQ_SOFTBARRIER) != 0)"
elif compile_module "BIO_RW_BARRIER" "linux/fs.h"
then
add_define "CAS_CHECK_BARRIER(bio) \\
(bio_rw_flagged((bio), BIO_RW_BARRIER))"
fi
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "RQF_SOFTBARRIER" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "REQ_SOFTBARRIER" "linux/blk_types.h"
then
echo $cur_name "2" >> $config_file_path
elif compile_module $cur_name "BIO_RW_BARRIER" "linux/fs.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_CHECK_BARRIER(bio) \\
((CAS_BIO_OP_FLAGS(bio) & RQF_SOFTBARRIER) != 0)" ;;
"2")
add_define "CAS_CHECK_BARRIER(bio) \\
((CAS_BIO_OP_FLAGS(bio) & REQ_SOFTBARRIER) != 0)" ;;
"3")
add_define "CAS_CHECK_BARRIER(bio) \\
(bio_rw_flagged((bio), BIO_RW_BARRIER))" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,29 +4,52 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "WRITE_FLUSH_FUA" "linux/fs.h"
then
add_define "CAS_WRITE_FLUSH_FUA \\
WRITE_FLUSH_FUA"
if compile_module "BIO_FUA" "linux/bio.h"
then
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((BIO_FUA | BIO_FLUSH) == ((flags) & (BIO_FUA | BIO_FLUSH)))"
else
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((REQ_FUA | CAS_REQ_FLUSH) == ((flags) & (REQ_FUA | CAS_REQ_FLUSH)))"
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "WRITE_FLUSH_FUA" "linux/fs.h"
then
if compile_module $cur_name "BIO_FUA" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
elif compile_module $cur_name "REQ_PREFLUSH" "linux/blk_types.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "4" >> $config_file_path
fi
elif compile_module "REQ_PREFLUSH" "linux/blk_types.h"
then
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((REQ_PREFLUSH | REQ_FUA) == ((flags) & (REQ_PREFLUSH |REQ_FUA)))"
add_define "CAS_WRITE_FLUSH_FUA \\
(REQ_PREFLUSH | REQ_FUA)"
else
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
0"
add_define "CAS_WRITE_FLUSH_FUA \\
WRITE_BARRIER"
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_WRITE_FLUSH_FUA \\
WRITE_FLUSH_FUA"
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((BIO_FUA | BIO_FLUSH) == ((flags) & (BIO_FUA | BIO_FLUSH)))" ;;
"2")
add_define "CAS_WRITE_FLUSH_FUA \\
WRITE_FLUSH_FUA"
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((REQ_FUA | CAS_REQ_FLUSH) == ((flags) & (REQ_FUA | CAS_REQ_FLUSH)))" ;;
"3")
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
((REQ_PREFLUSH | REQ_FUA) == ((flags) & (REQ_PREFLUSH |REQ_FUA)))"
add_define "CAS_WRITE_FLUSH_FUA \\
(REQ_PREFLUSH | REQ_FUA)" ;;
"4")
add_define "CAS_IS_WRITE_FLUSH_FUA(flags) \\
0"
add_define "CAS_WRITE_FLUSH_FUA \\
WRITE_BARRIER" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,36 +4,53 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "blk_make_request(NULL, NULL, 0)" "linux/blkdev.h"
then
add_function "
static inline struct request *cas_blk_make_request(struct request_queue *q,
struct bio *bio, gfp_t gfp_mask)
{
return blk_make_request(q, bio, gfp_mask);
}"
else
add_function "
static inline struct request *cas_blk_make_request(struct request_queue *q,
struct bio *bio, gfp_t gfp_mask)
{
struct request *rq = blk_get_request(q, bio_data_dir(bio), gfp_mask);
if (IS_ERR(rq))
return rq;
cas_blk_rq_set_block_pc(rq);
rq->q = q;
for_each_bio(bio) {
struct bio *bounce_bio = bio;
int ret;
cas_blk_queue_bounce(q, &bounce_bio);
ret = cas_blk_rq_append_bio(rq, bounce_bio);
if (unlikely(ret)) {
blk_put_request(rq);
return ERR_PTR(ret);
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "blk_make_request(NULL, NULL, 0)" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_function "
static inline struct request *cas_blk_make_request(struct request_queue *q,
struct bio *bio, gfp_t gfp_mask)
{
return blk_make_request(q, bio, gfp_mask);
}" ;;
"2")
add_function "
static inline struct request *cas_blk_make_request(struct request_queue *q,
struct bio *bio, gfp_t gfp_mask)
{
struct request *rq = blk_get_request(q, bio_data_dir(bio), gfp_mask);
if (IS_ERR(rq))
return rq;
cas_blk_rq_set_block_pc(rq);
rq->q = q;
for_each_bio(bio) {
struct bio *bounce_bio = bio;
int ret;
cas_blk_queue_bounce(q, &bounce_bio);
ret = cas_blk_rq_append_bio(rq, bounce_bio);
if (unlikely(ret)) {
blk_put_request(rq);
return ERR_PTR(ret);
}
}
}
return rq;
}"
fi
return rq;
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,35 +4,54 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "blk_queue_write_cache(NULL, 0, 0)" "linux/blkdev.h"
then
add_define "CAS_CHECK_QUEUE_FLUSH(q) \\
test_bit(QUEUE_FLAG_WC, &(q)->queue_flags)"
add_define "CAS_CHECK_QUEUE_FUA(q) \\
test_bit(QUEUE_FLAG_FUA, &(q)->queue_flags)"
add_function "
static inline void cas_set_queue_flush_fua(struct request_queue *q,
bool flush, bool fua)
{
blk_queue_write_cache(q, flush, fua);
}"
elif compile_module "struct request_queue rq;rq.flush_flags" "linux/blkdev.h"
then
add_define "CAS_CHECK_QUEUE_FLUSH(q) \\
((q)->flush_flags & CAS_REQ_FLUSH)"
add_define "CAS_CHECK_QUEUE_FUA(q) \\
((q)->flush_flags & REQ_FUA)"
add_function "static inline void cas_set_queue_flush_fua(struct request_queue *q,
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "blk_queue_write_cache(NULL, 0, 0)" "linux/blkdev.h"
then
echo $cur_name "1" >> $config_file_path
elif compile_module $cur_name "struct request_queue rq;rq.flush_flags" "linux/blkdev.h"
then
echo $cur_name "2" >> $config_file_path
else
echo $cur_name "X" >> $config_file_path
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_CHECK_QUEUE_FLUSH(q) \\
test_bit(QUEUE_FLAG_WC, &(q)->queue_flags)"
add_define "CAS_CHECK_QUEUE_FUA(q) \\
test_bit(QUEUE_FLAG_FUA, &(q)->queue_flags)"
add_function "
static inline void cas_set_queue_flush_fua(struct request_queue *q,
bool flush, bool fua)
{
unsigned int flags = 0;
if (flush)
flags |= CAS_REQ_FLUSH;
if (fua)
flags |= REQ_FUA;
if (flags)
blk_queue_flush(q, flags);
}"
fi
{
blk_queue_write_cache(q, flush, fua);
}" ;;
"2")
add_define "CAS_CHECK_QUEUE_FLUSH(q) \\
((q)->flush_flags & CAS_REQ_FLUSH)"
add_define "CAS_CHECK_QUEUE_FUA(q) \\
((q)->flush_flags & REQ_FUA)"
add_function "static inline void cas_set_queue_flush_fua(struct request_queue *q,
bool flush, bool fua)
{
unsigned int flags = 0;
if (flush)
flags |= CAS_REQ_FLUSH;
if (fua)
flags |= REQ_FUA;
if (flags)
blk_queue_flush(q, flags);
}" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -4,35 +4,60 @@
# SPDX-License-Identifier: BSD-3-Clause-Clear
#
. `dirname $0`/conf_framework
. $(dirname $3)/conf_framework
if compile_module "WRITE_FLUSH" "linux/fs.h"
then
add_define "CAS_RQ_IS_FLUSH(rq) \\
((rq)->cmd_flags & CAS_REQ_FLUSH)"
add_define "CAS_WRITE_FLUSH \\
WRITE_FLUSH"
if compile_module "BIO_FLUSH" "linux/bio.h"
then
add_define "CAS_IS_WRITE_FLUSH(flags) \\
((flags) & BIO_FLUSH)"
else
add_define "CAS_IS_WRITE_FLUSH(flags) \\
((flags) & CAS_REQ_FLUSH)"
check() {
cur_name=$(basename $2)
config_file_path=$1
if compile_module $cur_name "WRITE_FLUSH" "linux/fs.h"
then
if compile_module $cur_name "BIO_FLUSH" "linux/bio.h"
then
echo $cur_name "1" >> $config_file_path
else
echo $cur_name "2" >> $config_file_path
fi
elif compile_module $cur_name "REQ_PREFLUSH" "linux/blk_types.h"
then
echo $cur_name "3" >> $config_file_path
else
echo $cur_name "4" >> $config_file_path
fi
elif compile_module "REQ_PREFLUSH" "linux/blk_types.h"
then
add_define "CAS_RQ_IS_FLUSH(rq) \\
((rq)->cmd_flags & REQ_PREFLUSH)"
add_define "CAS_WRITE_FLUSH \\
(REQ_OP_WRITE | REQ_PREFLUSH)"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
(CAS_WRITE_FLUSH == ((flags) & CAS_WRITE_FLUSH))"
else
add_define "CAS_RQ_IS_FLUSH(rq) \\
0"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
(WRITE_BARRIER == ((flags) & WRITE_BARRIER))"
add_define "CAS_WRITE_FLUSH \\
WRITE_BARRIER"
fi
}
apply() {
case "$1" in
"1")
add_define "CAS_RQ_IS_FLUSH(rq) \\
((rq)->cmd_flags & CAS_REQ_FLUSH)"
add_define "CAS_WRITE_FLUSH \\
WRITE_FLUSH"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
((flags) & BIO_FLUSH)" ;;
"2")
add_define "CAS_RQ_IS_FLUSH(rq) \\
((rq)->cmd_flags & CAS_REQ_FLUSH)"
add_define "CAS_WRITE_FLUSH \\
WRITE_FLUSH"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
((flags) & CAS_REQ_FLUSH)" ;;
"3")
add_define "CAS_RQ_IS_FLUSH(rq) \\
((rq)->cmd_flags & REQ_PREFLUSH)"
add_define "CAS_WRITE_FLUSH \\
(REQ_OP_WRITE | REQ_PREFLUSH)"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
(CAS_WRITE_FLUSH == ((flags) & CAS_WRITE_FLUSH))" ;;
"4")
add_define "CAS_RQ_IS_FLUSH(rq) \\
0"
add_define "CAS_IS_WRITE_FLUSH(flags) \\
(WRITE_BARRIER == ((flags) & WRITE_BARRIER))"
add_define "CAS_WRITE_FLUSH \\
WRITE_BARRIER" ;;
*)
exit 1
esac
}
conf_run $@

View File

@ -6,12 +6,10 @@
SCRIPTPATH=`dirname $0`
SCRIPTPATH=`realpath $SCRIPTPATH`
MODULE_FILE=$SCRIPTPATH/test_mod.c
OBJ_MOD=$SCRIPTPATH/test_mod.o
KERNEL_DIR="${KERNEL_DIR:-/lib/modules/$(uname -r)/build/}"
KERNEL_VER="$(cd $KERNEL_DIR; make kernelversion)"
NPROC=`nproc`
DEFINE_FILE=$SCRIPTPATH/../modules/generated_defines.h
DEFINE_FILE=$SCRIPTPATH/modules/generated_defines.h
add_define() {
@ -23,41 +21,58 @@ add_function() {
}
compile_module(){
if [ $# -gt 1 ]
if [ $# -gt 2 ]
then
INCLUDE="#include <$2>"
INCLUDE="#include <$3>"
else
INCLUDE=""
fi
config_file=$1
test_module_dir=$SCRIPTPATH/configure.d/${config_file}_dir
test_module_file=$test_module_dir/test_mod.c
test_module_obj=$test_module_dir/test_mod.o
mkdir -p $test_module_dir
cp -f $SCRIPTPATH/configure.d/Makefile $test_module_dir
############# TEST MODULE #############
cat > $MODULE_FILE <<- EOF
cat > $test_module_file <<- EOF
#include <linux/module.h>
#include <linux/kernel.h>
$INCLUDE
int init_module(void) {
$1;
$2;
return 0;
}
void cleanup_module(void) {};
EOF
#######################################
make -C $SCRIPTPATH KERNEL_DIR=${KERNEL_DIR} &> /dev/null
make -C $test_module_dir KERNEL_DIR=${KERNEL_DIR} &> /dev/null
local ret=$?
if [ $ret -eq 0 ]; then
make -C $SCRIPTPATH clean &> /dev/null
fi
rm -Rf $test_module_dir
return $ret
}
kernel_not_supp_fail() {
echo "Current kernel is not supported!"
rm $DEFINE_FILE
exit 1
echo "Current kernel is not supported!"
rm $DEFINE_FILE
exit 1
}
# $1 - name of function to be called
# $2 - path to file with valid configs
# $3 - name of processed template file
conf_run() {
case "$1" in
"check") check $2 $3;;
"apply") apply $2 ;;
esac
}
IFS='?'